import java.util.Iterator;


public class SimplifiedTextMergeViewer {

	private boolean fHighlightRanges;
	
	private boolean fShowCurrentOnly2;
	
	private ChangeDiffs fChangeDiffs;
	
	private Merger fMerger;
	
	public static Object Default_Color = new Object();
	
	public static int LW = 0;	
	
public void paintSides(GC g, MergeSourceViewer tp, Canvas canvas, boolean right){
	
	Display display= canvas.getDisplay();

	if (! fHighlightRanges)
		return;

	if (fMerger != null) {
			
		Point region= new Point(0, 0);
		char leg = getLeg(tp);
		for(Iterator iterator = fMerger.changesIterator(); iterator.hasNext();){
			Diff diff= (Diff) iterator.next();
			if (diff.isDeleted())
				continue;
			
			if (fShowCurrentOnly2 && !isCurrentDiff(diff))
				continue;

			tp.getLineRange(diff.getPosition(leg), region);	
				
			g.setBackground(getColor(display, getFillColor(diff)));
			
			g.setLineWidth(0 /* LW */);
			g.setForeground(getColor(display, getStrokeColor(diff)));
		}
	}
}

private Object getColor(Display display, Object obj){
	return null;
}

private Object getFillColor(Diff diff){
	return null;
}

private char getLeg(MergeSourceViewer tp){
	return ' ';
}

private Object getStrokeColor(Diff diff){
	return null;
}

public Diff handleMouseInSides(Canvas canvas, MergeSourceViewer tp, int my) {

		int lineHeight= tp.getTextWidget().getLineHeight();
		int visibleHeight= tp.getViewportHeight();

		if (! fHighlightRanges)
			return null;

		if (fMerger != null) {
			int shift= tp.getVerticalScrollOffset() + (2-LW);

			Point region= new Point(0, 0);
			char leg = getLeg(tp);
			for(Iterator iterator = fMerger.changesIterator(); iterator.hasNext();){
				Diff diff = (Diff)iterator.next();
				if (diff.isDeleted())
					continue;

				if (fShowCurrentOnly2 && !isCurrentDiff(diff))
					continue;

				tp.getLineRange(diff.getPosition(leg), region);
				int y= (region.x * lineHeight) + shift;
				int h= region.y * lineHeight;
					
				if (my >= y && my < y+h)
					return diff;
			}
		}
		return null;
	}

public boolean isCurrentDiff(Diff diff){
	return false;
}


}

class Canvas{

Object getBackground(){
	return null;
}

Display getDisplay(){ 
	return new Display();
}

Point getSize(){
	return new Point(0, 0);
}
}

class ChangeDiffs{
Iterator iterator(){
	return null;
}
}

class Diff{

Point getPosition(MergeSourceViewer tp){
	return new Point(0, 0);
}

Point getPosition(char leg){
	return new Point(0, 0);
}

boolean isDeleted(){
	return false;
}
}

class Display{

Object getSystemColor(Object setting){
	return null;
}
}


class GC{

void drawRectangle(int x1, int x2, int y1, int y2){
	
}

void setBackground(Object obj){
	
}

void setForeground(Object obj){
	
}

public void setLineWidth(int i){
	
}

void fillRectangle(int x1, int x2, int x3, int x4){
	
}
}

class MergeSourceViewer{

void getLineRange(Point position, Point region){
	
}

TextWidget getTextWidget(){
	return new TextWidget();
}

int getVerticalScrollOffset(){
	return 0;
}

int getViewportHeight(){
	return 0;
}
}

class Merger{
	boolean hasChanges(){
		return false;
	}
	
	Iterator changesIterator(){
		return null;
	}
}

class Point{
int x, y;

Point(int i, int j){
	x = i;
	y = j;
}
}

class TextWidget{
int getLineHeight(){
	return 0;
}
}
